#### Goal: Convert daily rain or irradiance data into lookup tables.
# The rain input file holds ndays & rain (mm). 
# The irradiance input file holds ndays & MJm2.
# ndays is the date expressed as the number of days since 1980-01-01.
# Columns 1 to 360 of the lookup tables hold summed values for 1 to 360 days
# before the date in column 361, respectively. The date is 

setwd("c:/Users/wrightj/Dropbox/Clouds/RMSE/Dryad") # Supply your work directory

# Create solar irradiance lookup table. 
infile = "Daily_Solar_Radiation.txt" # ndays & MJm2
outfile = "LookUp_Irradiance.txt"
z = read.table(infile,header=T,sep="\t") # ndays, MJ m-2 & time
duration = 360
firstday = min(z$ndays)+duration
lastday = max(z$ndays)
d = matrix(NA,nrow=dim(z)[1]-duration,ncol=duration+1)
for (i in firstday:lastday) {
  row = i-(firstday-1)
  for (j in 1:duration) { d[row,j]=sum(z$MJm2[z$ndays>=(i-j) & z$ndays<i]) }
  d[row,duration+1] = i
}
write.table(d,outfile,row.names=F,sep="\t")


# Create rain lookup table. 
infile = "Daily_Rainfall.txt" # ndays & rain (mm)
outfile = "LookUp_Rain.txt"
# Import data.
z = read.table(infile,header=T,sep="\t") # ndays & rain (mm)
duration = 360
firstday = min(z$ndays)+duration
lastday = max(z$ndays)
d = matrix(NA,nrow=dim(z)[1]-duration,ncol=362)
for (i in firstday:lastday) {
  row = i-(firstday-1)
  for (j in 1:duration) { d[row,j]=sum(z$rain[z$ndays>=(i-j) & z$ndays<i]) }
  d[row,duration+1] = i
}
write.table(d,outfile,row.names=F,sep="\t")
